SystemOrganization addCategory: #'TADP-Meta-programacion-tp'!
SystemOrganization addCategory: #'TADP-Meta-programacion-tp-test'!

TestCase subclass: #TestClassSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp-test'!

!TestClassSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/3/2013 23:59'!
testGetClassUsingDummySelector
	|selector ret |
	selector := DummyClassSelector new.

	ret := selector selectClass detect: [ :each | each = Gauchita class]  ifNone: nil.
	
	self assert:  (ret = Gauchita class).! !

!TestClassSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 00:16'!
testGetNoneClassUsingDummySelector
	|selector ret |
	selector := DummyClassSelector new.

	ret := selector selectClass detect: [ :each | each = Intocable class]  ifNone: nil.
	
	self assert:  (ret isNil).! !

TestCase subclass: #TestInterceptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp-test'!

!TestInterceptor methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 00:33'!
testSubsetOfClassAndMethodsUniverse
	|interceptor aClassSelector aMethodSelector subset |
	interceptor := Interceptor new.
	aClassSelector := DummyClassSelector new.
	aMethodSelector := DummyMethodSelector  new.
	
	subset:= interceptor getClassAndMethodsFromTheUniverseWith: aClassSelector and: aMethodSelector.
	
	self shouldnt:(subset isNil).
	self deny: (subset keys detect: [:each | each = (Gauchita class)] ifNone: nil) isNil .! !

TestCase subclass: #TestMethodSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp-test'!

!TestMethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 00:25'!
testGetMethodUsinngDummySelector
	|selector ret |
	selector := DummyMethodSelector new.
	
	ret := (selector selectMethodFrom: Gauchita class) detect:[:each | each = #dummySelector]  ifNone: nil .
	
	self assert:  (#dummySelector = ret).! !

!TestMethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 00:26'!
testGetNoMethodUsinngDummySelector
	|selector ret |
	selector := DummyMethodSelector new.
	
	ret := (selector selectMethodFrom: Gauchita class) detect:[:each | each = #smartSelector]  ifNone: nil .
	
	self assert:  (ret isNil).! !

Object subclass: #ClassSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!ClassSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/3/2013 23:59'!
selectClass
	|classes|
	classes := Set new.
	
	^classes.! !

ClassSelector subclass: #DummyClassSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!DummyClassSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/3/2013 23:58'!
selectClass
	|classes|
	classes := Set new.
	classes add: (Gauchita class) .
	
	^classes.! !

Object subclass: #Gauchita
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!Gauchita class methodsFor: 'as yet unclassified' stamp: 'joseflores 5/3/2013 01:33'!
imprimiteAlgo ^'Lddddedas' ! !

!Gauchita methodsFor: 'as yet unclassified' stamp: 'joseflores 5/3/2013 01:22'!
imprimiteAlgo ^'Dale' ! !

Object subclass: #Interceptor
	instanceVariableNames: 'methodSelector classSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/3/2013 21:57'!
classSelector
	^ classSelector! !

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/3/2013 21:57'!
classSelector: anObject
	classSelector := anObject! !

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 00:30'!
getClassAndMethodsFromTheUniverseWith: aClassSelector and: aMethodSelector
	|classToIntercept methodsToIntercept interceptionCenter|
	classToIntercept := Set new.
	interceptionCenter := Dictionary new.
	
	classToIntercept := aClassSelector selectClass.
	
	classToIntercept do: [:eachClass | interceptionCenter add: (Association key: eachClass  value: (aMethodSelector selectMethodFrom: eachClass) )].
	^interceptionCenter.! !

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/3/2013 22:16'!
interceptWith: aMethodBefore and: aMethodAfter
	|classToIntercept methodsToIntercept interceptionCenter|
	interceptionCenter :=  self getClassAndMethodsFromTheUniverseWith: self classSelector and: self methodSelector.
	
	! !

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/3/2013 21:57'!
methodSelector
	^ methodSelector! !

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/3/2013 21:57'!
methodSelector: anObject
	methodSelector := anObject! !

Object subclass: #Intocable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!Intocable class methodsFor: 'as yet unclassified' stamp: 'joseflores 5/3/2013 01:11'!
imprimiteAlgo
	^'No che'.! !

Object subclass: #MethodSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

MethodSelector subclass: #DummyMethodSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!DummyMethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 00:21'!
selectMethodFrom: aClass
	|methods|
	methods := Set new.
	methods add: #dummySelector.
	methods add: #dumbSelector.
	
	^methods.
! !

!MethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 00:20'!
selectMethodFrom: aClass
	|methods|
	methods := Set new.

	^methods.
	! !

!MethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/3/2013 00:25'!
selectMethodFrom: aClass startingWith: aText
	^[ aClass methodDict collect: [:each | each selector indexOfString aText] ]! !

Object subclass: #QueTocas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!QueTocas class methodsFor: 'as yet unclassified' stamp: 'joseflores 5/3/2013 01:11'!
imprimiteAlgo
	^'Histeria'.! !
